/*
 * Copyright 1993-95 Vectaport Inc, Jorge A. Gautier Consulting, Cider Press
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#ifndef vpfcmds_h
#define vpfcmds_h

#include <Unidraw/Commands/command.h>

#include <MapUnidraw/mapcmds.h>


class MapDatabase;
class MapLibrary;

class VpfOpenCmd : public MapOpenCmd {
public:
    VpfOpenCmd(ControlInfo*, OpenFileChooser* = nil);
    VpfOpenCmd(Editor* = nil, OpenFileChooser* = nil);

    virtual void Execute();

    virtual Command* Copy();
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
};

class VpfShowTilesCmd : public Command {
public:
    VpfShowTilesCmd(ControlInfo*);
    VpfShowTilesCmd(Editor* = nil);

    virtual void Execute();
    virtual boolean Reversible();

    virtual Command* Copy();
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
protected:
    MapLibrary* choosetiledlib(MapDatabase*);
};

class VpfToolbarCmd : public Command {
public:
    VpfToolbarCmd(ControlInfo*, boolean tiled = false);
    VpfToolbarCmd(Editor* = nil, boolean tiled = false);

    virtual void Execute();
    virtual boolean Reversible();

    virtual Command* Copy();
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
protected:
    boolean _tiled;
};

class VpfUpdateMenusCmd : public Command {
public:
    VpfUpdateMenusCmd(ControlInfo*);
    VpfUpdateMenusCmd(Editor* = nil);

    virtual void Execute();
    virtual boolean Reversible();

    virtual Command* Copy();
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);
};

class VpfGraticuleCmd : public Command {
public:
    VpfGraticuleCmd(ControlInfo*);
    VpfGraticuleCmd(Editor* = nil);

    virtual Command* Copy();
    virtual void Execute();
};

#endif
